"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.promise");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/slicedToArray"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _loadableContext = _interopRequireDefault(require("./loadableContext"));

var _store = require("./store");

var connectedComponent = function connectedComponent(_ref) {
  var view = _ref.view,
      reducer = _ref.reducer,
      saga = _ref.saga,
      viewProps = _ref.viewProps;
  var View = view;
  return _react.default.createElement(_loadableContext.default.Consumer, null, function (_ref2) {
    var errorBoundary = _ref2.errorBoundary;
    var ErrorBoundary = errorBoundary;
    return _react.default.createElement(ErrorBoundary, null, _react.default.createElement(_reactRedux.ReactReduxContext.Consumer, null, function (_ref3) {
      var store = _ref3.store;
      (0, _store.injectAsyncStore)(store, reducer, saga);
      return _react.default.createElement(View, (0, _assign.default)({}, viewProps));
    }));
  });
};

var unConnectedComponent = function unConnectedComponent() {
  return _react.default.createElement(_loadableContext.default.Consumer, null, function (_ref4) {
    var loadingBoundary = _ref4.loadingBoundary;
    return loadingBoundary;
  });
};

var ReactReduxConnectedComponent =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(ReactReduxConnectedComponent, _React$Component);

  function ReactReduxConnectedComponent(props) {
    var _this;

    (0, _classCallCheck2.default)(this, ReactReduxConnectedComponent);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ReactReduxConnectedComponent).call(this, props));

    _this.loadCom = function (props) {
      var reducer = props.reducer,
          saga = props.saga,
          view = props.view,
          viewProps = props.viewProps;
      var promises = [view()];
      reducer && promises.push(reducer());
      saga && promises.push(saga());

      _promise.default.all(promises).then(function (values) {
        var _values = (0, _slicedToArray2.default)(values, 3),
            _view = _values[0],
            _reducer = _values[1],
            _saga = _values[2];

        _this.mount && _this.setState({
          component: connectedComponent({
            view: _view.default,
            reducer: _reducer && _reducer.default,
            saga: _saga && _saga.default,
            viewProps: viewProps
          })
        });
      });
    };

    _this.state = {
      component: unConnectedComponent()
    };
    _this.mount = false;
    return _this;
  }

  (0, _createClass2.default)(ReactReduxConnectedComponent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mount = true;
      this.loadCom(this.props);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      this.loadCom(nextProps);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mount = false;
    }
  }, {
    key: "render",
    value: function render() {
      return this.state.component;
    }
  }]);
  return ReactReduxConnectedComponent;
}(_react.default.Component);

exports.default = ReactReduxConnectedComponent;