"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _errorBoundary = _interopRequireDefault(require("./error/errorBoundary"));

var _loadableContext = _interopRequireDefault(require("./loadableContext"));

var _store = _interopRequireDefault(require("./store"));

var defaultLoading = _react.default.createElement("div", null, "loading...");

var _default = function _default(_ref) {
  var children = _ref.children,
      initReducer = _ref.initReducer,
      _ref$reduxMiddlewares = _ref.reduxMiddlewares,
      reduxMiddlewares = _ref$reduxMiddlewares === void 0 ? [] : _ref$reduxMiddlewares,
      _ref$loadingBoundary = _ref.loadingBoundary,
      loadingBoundary = _ref$loadingBoundary === void 0 ? defaultLoading : _ref$loadingBoundary,
      _ref$errorBoundary = _ref.errorBoundary,
      errorBoundary = _ref$errorBoundary === void 0 ? _errorBoundary.default : _ref$errorBoundary;
  var store = (0, _store.default)(initReducer, reduxMiddlewares);
  return _react.default.createElement(_reactRedux.Provider, {
    store: store
  }, _react.default.createElement(_loadableContext.default.Provider, {
    value: {
      loadingBoundary: loadingBoundary,
      errorBoundary: errorBoundary
    }
  }, children));
};

exports.default = _default;