"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.promise");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.injectAsyncStore = injectAsyncStore;
exports.rejectAsyncStore = rejectAsyncStore;
exports.default = initStore;

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _interopRequireWildcard2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/interopRequireWildcard"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/toConsumableArray"));

var _redux = require("redux");

var _reduxLogger = require("redux-logger");

var _reduxSaga = _interopRequireDefault(require("redux-saga"));

var _reducers = _interopRequireDefault(require("./reducers"));

var logger = (0, _reduxLogger.createLogger)();
var win = window;

function injectAsyncStore(store, asyncReducers, sagas) {
  asyncReducers && injectAsyncReducers(store, asyncReducers);
  sagas && injectAsyncSagas(store, sagas);
}

function injectAsyncReducers(store, asyncReducers) {
  var flag = false;

  for (var key in asyncReducers) {
    if (Object.prototype.hasOwnProperty.call(asyncReducers, key)) {
      if (!store.asyncReducers[key]) {
        store.asyncReducers[key] = asyncReducers[key];
        flag = true;
      }
    }
  }

  flag && store.replaceReducer((0, _reducers.default)(store.asyncReducers));
}

function injectAsyncSagas(store, sagas) {
  for (var key in sagas) {
    if (Object.prototype.hasOwnProperty.call(sagas, key)) {
      if (!store.asyncSagas[key]) {
        store.asyncSagas[key] = sagas[key];
        store.sagaMiddleware.run(sagas[key]);
      }
    }
  }
}

function rejectAsyncStore(store) {
  var asyncReducers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  asyncReducers && rejectAsyncReducers(store, asyncReducers);
}

function rejectAsyncReducers(store, asyncReducers) {
  var flag = false;

  for (var key in asyncReducers) {
    if (Object.prototype.hasOwnProperty.call(asyncReducers, key)) {
      if (store.asyncReducers[key]) {
        delete store.asyncReducers[key];
        flag = true;
      }
    }
  }

  flag && store.replaceReducer((0, _reducers.default)(store.asyncReducers));
}

function initStore() {
  var initReducer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var reduxMiddlewares = arguments.length > 1 ? arguments[1] : undefined;
  var sagaMiddleware = (0, _reduxSaga.default)();
  var middlewares = [].concat((0, _toConsumableArray2.default)(reduxMiddlewares), [sagaMiddleware]);

  if (process.env.NODE_ENV !== 'production') {
    _promise.default.resolve().then(function () {
      return (0, _interopRequireWildcard2.default)(require('redux-immutable-state-invariant'));
    }).then(function (_ref) {
      var _ = _ref.default;
      middlewares.push(_());
    });
  }

  var storeEnhancers = (0, _redux.compose)(_redux.applyMiddleware.apply(void 0, (0, _toConsumableArray2.default)(middlewares).concat([logger])), win && win.__REDUX_DEVTOOLS_EXTENSION__ ? win.__REDUX_DEVTOOLS_EXTENSION__() : function (f) {
    return f;
  });
  var store = (0, _redux.createStore)((0, _reducers.default)(initReducer), storeEnhancers);
  return (0, _assign.default)({}, store, {
    asyncReducers: initReducer,
    asyncSagas: {},
    sagaMiddleware: sagaMiddleware
  });
}